import pygame
import random
import enemy
import item
from player import loadImage

walk = []
die = []

def setupAnimations():
	for i in range(1,9):
		path = "data//images//crusher//move//move" + str(i) + ".png"
		walk.append(loadImage(path))
	for i in range(1,9):
		path = "data//images//crusher//die//die" + str(i) + ".png"
		die.append(loadImage(path))


class Crusher(enemy.Enemy):	
	def __init__(self,screen,pos):
		self.screen = screen
		
		self.scoreValue	= 50
		self.health = 64
		self.rect = walk[0].get_rect()
		self.rect.centerx = pos[0]		
		self.rect.bottom = 300
		self.pos = self.rect.center
		self.rect.height = 85
		self.rect.bottom = 300
		self.drawrect = walk[0].get_rect()
		
		self.currentAnim = 0
		self.animFreq = 1
		self.anim = []
		
		self.attackVeloc = (-1,0)
		
		self.lastAttack = -1 #Stores attack that has already damaged the enemy ( so no getting damaged by the same attack)
		self.big = True
		self.mode = "WALK"
		# It may seem stupid but is for period when not alive but is not dead
		self.alive = True
		self.dead = False		
		self.scoreValue	= 750
		self.counter = 0
		self.walk()

	def update(self):
		i = None
		self.counter += 1		
		if self.counter % self.animFreq == 0:
			self.currentAnim = (self.currentAnim + 1) % len(self.anim)
				

		#print self.counter, self.counter % self.animFreq, self.currentAnim, self.mode
		if self.health <= 0:
			self.die()
		
		if (self.mode == "EXPLODE"):			
			if self.counter > 30:
				self.dead = True				
				i = item.Ramen(self.screen,(self.pos[0]-1, self.pos[1]+10))
		
		elif (self.mode == "WALK"):
			if self.counter % self.animFreq == 0:
				self.pos = (self.pos[0]-1,self.pos[1])
			if self.counter % 80 == 0 and self.attackVeloc[0] < 0:
				i = item.Laser(self.screen,((self.pos[0]-15)+(self.attackVeloc[0]),(self.pos[1]-12)+(self.attackVeloc[1])),self.attackVeloc)
			if self.counter > 90 and self.attackVeloc[0] < 0 and self.drawrect.left < 640:
				pass
			
		self.rect.centerx = self.pos[0]
		self.rect.bottom = 300
		return i	
			
		
	def walk(self):
		self.mode = "WALK"
		self.playAnim(walk,4)
		self.counter = 0		
		
	def die(self):
		if self.alive:
			self.alive = False
			self.mode = "EXPLODE"
			self.playAnim(die,4)
			self.drawrect = die[0].get_rect()
			self.drawrect.centerx = self.pos[0]
			self.drawrect.bottom = 300
			self.pos = self.drawrect.center
			self.counter = 0				
		
	def collidePlayer(self,player):
		if self.cp(player):
			player.hurt()
		xdif = (player.pos[0] - (self.pos[0]-15))
		ydif = (player.pos[1] - (self.pos[1]-12))
		d = (xdif**2 + ydif**2)**0.5
		if d == 0:
			d = 0.01
		self.attackVeloc = ((12.0/d)*xdif,(12.0/d)*ydif)
	def unburn(self):
		pass
	def burn(self):
		pass
	def knockback(self):
		pass
	def __repr__(self):
		return "{CRUSHER->(%r,%r)}" % (str(self.pos[0]),str(self.pos[1]))	
