import pygame
import random
import enemy
import item
from player import loadImage

comeout = []
fire = []
die = []
closed = []

def setupAnimations():
	for i in range(1,5):
		path = "data//images//platform//openclose//openclose" + str(i) + ".png"
		comeout.append(loadImage(path))
	for i in range(0,11):
		path = "data//images//platform//die//die" + str(i) + ".png"
		die.append(loadImage(path))
	for a in range(3):
		for b in range(2):
			folder = "fire"
			if a == 0:
				folder += "b"
			if a == 1:
				folder += "m"
			if a == 2:
				folder += "t"
			if b == 0:
				folder += "l"
			if b == 1:
				folder += "r"
			print folder	
			f = []
			for i in range(1,5):
				path = "data//images//platform//fire//"+folder+"//fire" + str(i) + ".png"
				f.append(loadImage(path))
			fire.append(f)
	closed.append(comeout[3])


class Platform(enemy.Enemy):	
	def __init__(self,screen,pos):
		self.screen = screen
		
		self.scoreValue	= 30
		self.health = 24
		self.rect = closed[0].get_rect()
		self.rect.centerx = pos[0]
		self.rect.bottom = 300
		self.pos = self.rect.center
		self.rect = pygame.Rect(0,0,60,40)
		self.drawrect = closed[0].get_rect()
		
		self.currentAnim = 0
		self.currentMissile = 0
		self.animFreq = 1
		self.anim = []
		
		self.lastAttack = -1 #Stores attack that has already damaged the enemy ( so no getting damaged by the same attack)
		self.big = False
		self.mode = "WAIT"
		# It may seem stupid but is for period when not alive but is not dead
		self.alive = True
		self.dead = False		
		self.scoreValue	= 500
		self.counter = 0
		self.wait()

	def update(self):
		i = None
		self.counter += 1		
		if self.mode == "OPEN":
			if self.counter % self.animFreq == 0:
				self.currentAnim = (self.currentAnim - 1) % len(self.anim)
		else:
			if self.counter % self.animFreq == 0:
				self.currentAnim = (self.currentAnim + 1) % len(self.anim)
				

		#print self.counter, self.counter % self.animFreq, self.currentAnim, self.mode
		if self.health <= 0:
			self.die()
		print self.mode
		if (self.mode == "EXPLODE"):			
			if self.counter > 21:
				self.dead = True
				i = item.Ramen(self.screen,self.pos)
		
		elif self.mode == "RELOAD":
			if self.counter > 50:
				self.open()	
				
		elif self.mode == "OPEN":
			if self.counter > 14:
				self.fire()	
				
		elif self.mode == "CLOSE":
			if self.counter > 14:
				self.reload()
				
		elif self.mode == "FIRE":
			if self.counter == 10:
				r = 8-(self.currentMissile/2)*8
				i = item.Missile(self.screen,(self.pos[0],self.pos[1]+r))
			if self.counter > 20:
				self.close()					
			
		self.rect.centerx = self.pos[0]
		self.rect.bottom = 300
		return i	
			
		
	def wait(self):
		self.mode = "WAIT"
		self.playAnim(closed,10)
		self.counter = 0		
	def close(self):
		self.mode = "CLOSE"
		self.playAnim(comeout,4)
		self.counter = 0
		
	def open(self):
		self.mode = "OPEN"
		self.playAnim(comeout,4)
		self.counter = 0
		self.currentAnim = 3		
	def fire(self):
		if self.currentMissile >= 6:
			self.currentMissile = 0					
		self.playAnim(fire[self.currentMissile],3)
		self.currentMissile += 1	
		self.mode = "FIRE"
		self.counter = 0
		
		
	def reload(self):
		self.playAnim(closed,10)
		self.mode = "RELOAD"
		self.counter = 0			
		
	def die(self):
		if self.alive:
			self.alive = False
			self.mode = "EXPLODE"
			self.playAnim(die,3)
			self.counter = 0				
		
	def collidePlayer(self,player):
		if self.cp(player):
			player.hurt()
		if self.mode == "WAIT":
			xdif = (player.pos[0] - self.pos[0])
			ydif = (player.pos[1] - self.pos[1])
			d = (xdif**2 + ydif**2)**0.5
			if d < 200:
				self.open()
		
	def unburn(self):
		pass
	def burn(self):
		if self.mode == "WAIT":
			self.open()
			self.counter = int(random.random()*4)
	def knockback(self):
		pass
	def __repr__(self):
		return "{MISSILE PLATFORM->(%r,%r)}" % (str(self.pos[0]),str(self.pos[1]))
