import pygame
import sys
from pygame.locals import *
import text
import level

class Warning(object):
	def __init__(self,screen):		
		self.screen = screen
		self.warningText = text.Text(screen,"EPILEPSY SIEZURE WARNING",(320,120),32)
		self.warningText2 = text.Text(screen,"THIS GAME FEATURES SOME FAST FLASHING!",(320,180),32)
		self.warningText2 = text.Text(screen,"PRESS SPACE TO CONTINUE (ESC TO EXIT)",(320,240),32)

	def update(self):
		for event in pygame.event.get():
			if event.type == KEYDOWN:
				if event.key == K_ESCAPE:
					return None
				else:
					channel = pygame.mixer.Channel(1)					
					sound = pygame.mixer.Sound("data//sound//confirm.wav")										
					channel.play(sound)				
					return Title(self.screen)

		return self

	def draw(self):		
		self.warningText.draw()
		self.warningText2.draw()
		
class Title(object):
	def __init__(self,screen):		
		self.screen = screen
		self.ready = False
		self.frame = 0
		self.keyPosition = 0
		self.texts = []
		self.cursor = text.FlashyText(self.screen,">>",(240,32),40)
		# initialize menu sounds and channels
		self.selectSound = pygame.mixer.Sound("data//sound//select.wav")
		self.confirmSound = pygame.mixer.Sound("data//sound//confirm.wav")
		self.music = pygame.mixer.Sound("data//sound//gameloop.ogg")
		self.musicChannel = pygame.mixer.Channel(0)
		self.soundChannel = pygame.mixer.Channel(1)
		self.musicChannel.stop()
		self.musicChannel.set_volume(0.5)
		self.musicChannel.play(self.music,-1)
	def getKeyInfo(self):
		for event in pygame.event.get():
			if event.type == KEYDOWN:
				if event.key == K_ESCAPE:
					if self.frame > 15:
						sys.exit()
				if event.key == K_UP:
					self.keyPosition = (self.keyPosition- 1) % 3
					self.soundChannel.play(self.selectSound)
				if event.key == K_DOWN:
					self.keyPosition = (self.keyPosition + 1) % 3
					self.soundChannel.play(self.selectSound)
				if event.key == K_RETURN or event.key == K_SPACE:
					self.soundChannel.play(self.confirmSound)
					if self.keyPosition == 1:						
						return "fullscreen"
					elif self.keyPosition == 2:						
						return None
					else:
						return Instructions(self.screen)				
		return self
	def drawMenuOptions(self):
		# Draw options
		a = text.Text(self.screen,"BEGIN!!!!",(360,270),32)
		b = text.Text(self.screen,"TOGGLE FULLSCREEN",(360,300),32)
		c = text.Text(self.screen,"EXIT",(360,330),32)
		a.draw()
		b.draw()
		c.draw()
		# Update cursor
		self.cursor.pos = (210,self.keyPosition*30+250)
		self.cursor.update()
		# Draw cursor
		self.cursor.draw()		
	def update(self):
		# Slowly bring up elements of menu
		if self.frame == 10:
			self.texts.append(text.FlashyText(self.screen,"TAU IS BETTER THAN PI PRESENTS:",(240,32),40))
		if self.frame == 25:
			self.texts.append(text.FlashyText(self.screen,"SUPER",(360,80),80))			
		if self.frame == 40:
			self.texts.append(text.FlashyText(self.screen,"SALARY",(360,130),80))
		if self.frame == 55:
			self.texts.append(text.FlashyText(self.screen,"MAN",(360,180),80))
		if self.frame == 70:
			self.texts.append(text.FlashyText(self.screen,"!!!!!!!",(360,230),80))
		if self.frame > 75:
			self.ready = True
		
		returnData = self.getKeyInfo()		
		
		for ctext in self.texts:
			ctext.update()
		self.frame += 1
		if self.ready:			
			return returnData		
		return self
		
	def draw(self):
		for ctext in self.texts:
			ctext.draw()
		if self.ready:
			self.drawMenuOptions()
			
class Instructions(object):
	def __init__(self,screen):
		self.screen = screen		
		self.frame = 0
		self.keyPosition = 0
		self.texts = []
		self.texts.append(text.Text(screen,"YOU HAD A TOUGH DAY AT WORK AND GOT DRUNK LAST NIGHT!",(320,55),32))
		self.texts.append(text.Text(screen,"YOU WAKE UP TO A BAD HANGOVER...",(320,95),32))
		self.texts.append(text.Text(screen,"...AND AN IMPENDING INVASION BY THE ROBOT MENACE!",(320,135),32))
		self.texts.append(text.Text(screen,"LEFT/RIGHT TO MOVE, UP TO JUMP",(320,175),32))		
		self.texts.append(text.Text(screen,"PRESS OR HOLD SPACE WITH UP/DOWN/RIGHT FOR ATTACKS",(320,215),32))
		self.texts.append(text.Text(screen,"PRESS UP-UP TO TRANSFORM WHEN POWER METER IS FULL",(320,255),32))
		self.texts.append(text.FlashyText(screen,"PRESS SPACE TO TRY AND SAVE HUMANITY",(320,330),32))
	def update(self):
		for t in self.texts:
			t.update()
		for event in pygame.event.get():
			if event.type == KEYDOWN:				
				if event.key == K_ESCAPE:
					return Title(self.screen)
				if event.key == K_SPACE:
					sound = pygame.mixer.Sound("data//sound//confirm.wav")
					channel = pygame.mixer.Channel(1)
					channel.play(sound)
					return level.Level(self.screen)
		return self
	def draw(self):
		for t in self.texts:
			t.draw()

class EndGame(object):
	def __init__(self,screen,score):
		self.screen = screen		
		self.frame = 0
		self.keyPosition = 0
		self.music = pygame.mixer.Sound("data//sound//gameloop.ogg")
		self.musicChannel = pygame.mixer.Channel(0)
		self.musicChannel.fadeout(2000)
		ch = pygame.mixer.Channel(1)
		ch.stop()		
		#ch.play(pygame.mixer.Sound("data//sound//death.wav"))
		self.texts = []
		self.texts.append(text.Text(screen,"YOU SCORED: ",(160,34),48))	
		self.texts.append(text.FlashyText(screen,str(score),(480,34),48))		
		if score < 10000:
			self.texts.append(text.Text(screen,"YOU HAD NO CHANCE TO SURVIVE. MAYBE NEXT TIME?",(320,64),30))
		elif score < 30000:
			self.texts.append(text.Text(screen,"YOU WERE JUST STARTING TO GET GOOD. WHAT HAPPENED?",(320,64),30))
		elif score < 60000:
			self.texts.append(text.Text(screen,"BECAUSE OF YOU, HUMANITY SURVIVES A LITTLE LONGER",(320,64),30))
		else:
			self.texts.append(text.Text(screen,"THE FEW WHO SURVIVE, WILL FOREVER REMEMBER YOUR NAME ",(320,64),30))
		
		self.texts.append(text.Text(screen,"PRESS SPACE TO TAKE ANOTHER SHOT AT THE ROBOT MENACE!",(320,114),30))
		# Image to go in here
		self.texts.append(text.Text(screen,"PRESS ESC TO RETURN TO TITLE!",(320,240),30))	
		self.texts.append(text.Text(screen,"PROGRAMMING AND BACKGROUND ART BY MATTHEW SMITH",(320,280),24))
		self.texts.append(text.Text(screen,"ENEMY, PLAYER ANIMATIONS AND PLAYER CONCEPT BY IAN LOH",(320,300),24))		
		self.texts.append(text.Text(screen,"SOUND FX MADE USING SFXR PROGRAM BY DRPETTER AT www.drpetter.se",(320,320),24))
		self.texts.append(text.Text(screen,"MUSIC BY FEAROFDARK AT 8bc.org/members/FearofDark/",(320,340),24))
		self.image = level.player.loadImage("data//images//gameover.png")
		self.imRect = self.image.get_rect()
		self.imRect.center = (320,180)
	def update(self):
		self.frame += 1
		for t in self.texts:
			t.update()
		for event in pygame.event.get():
			if self.frame > 30:
				if event.type == KEYDOWN:				
					if event.key == K_ESCAPE:
						return Title(self.screen)
					if event.key == K_SPACE:
						sound = pygame.mixer.Sound("data//sound//confirm.wav")
						
						channel = pygame.mixer.Channel(1)
						channel.play(sound)
						self.musicChannel.stop()
						self.musicChannel.set_volume(0.5)
						self.musicChannel.play(self.music,-1)
						return level.Level(self.screen)
		return self
	def draw(self):
		for t in self.texts:
			t.draw()
		self.screen.blit(self.image,self.imRect)